BEGIN;




--
-- Sequences for table CONFIG
--

CREATE SEQUENCE config_id_seq;

--
-- Table structure for table 'config'
--

CREATE TABLE config (
  config_name varchar(255) NOT NULL DEFAULT '',
  config_value text,
  id INT4 DEFAULT nextval('config_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'config'
--



--
-- Table structure for table 'content'
--

CREATE TABLE content (
  sid INT8  NOT NULL DEFAULT '0',
  content varchar(255) DEFAULT NULL,
  off_set varchar(4) DEFAULT NULL,
  depth varchar(4) DEFAULT NULL,
  nocase varchar(6) DEFAULT NULL,
  regex varchar(5) DEFAULT NULL
);

--
-- Dumping data for table 'content'
--



--
-- Table structure for table 'output'
--



--
-- Sequences for table OUTPUT
--

CREATE SEQUENCE output_id_seq;

CREATE TABLE output (
  spo_name varchar(255) NOT NULL DEFAULT '',
  spo_value text,
  id INT4 DEFAULT nextval('output_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'output'
--



--
-- Table structure for table 'preprocessor'
--



--
-- Sequences for table PREPROCESSOR
--

CREATE SEQUENCE preprocessor_id_seq;

CREATE TABLE preprocessor (
  spp_name varchar(255) NOT NULL DEFAULT '',
  spp_value text,
  id INT4 DEFAULT nextval('preprocessor_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'preprocessor'
--



--
-- Table structure for table 'reference'
--

CREATE TABLE reference (
  sid INT8 NOT NULL DEFAULT '0',
  reference varchar(255) DEFAULT NULL
);

--
-- Dumping data for table 'reference'
--



--
-- Table structure for table 'rulechange'
--

CREATE TABLE rulechange (
  sensor_id INT4  NOT NULL DEFAULT '0',
  sid INT4  NOT NULL DEFAULT '0',
  action varchar(255) NOT NULL DEFAULT '',
  src_ip varchar(255) NOT NULL DEFAULT '',
  src_port varchar(255) NOT NULL DEFAULT '',
  dst_ip varchar(255) NOT NULL DEFAULT '',
  dst_port varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (sensor_id,sid)
);

--
-- Dumping data for table 'rulechange'
--



--
-- Table structure for table 'rules'
--

CREATE TABLE rules (
  action varchar(15) NOT NULL DEFAULT '',
  proto varchar(5) NOT NULL DEFAULT '',
  src_ip varchar(255) NOT NULL DEFAULT '',
  src_port varchar(255) NOT NULL DEFAULT '',
  dst_ip varchar(255) NOT NULL DEFAULT '',
  dst_port varchar(255) NOT NULL DEFAULT '',
  msg varchar(255) DEFAULT NULL,
  logto varchar(255) DEFAULT NULL,
  ttl char(3) DEFAULT NULL,
  tos char(3) DEFAULT NULL,
  id varchar(5) DEFAULT NULL,
  ipoption varchar(5) DEFAULT NULL,
  fragbits varchar(10) DEFAULT NULL,
  dsize varchar(10) DEFAULT NULL,
  flags varchar(15) DEFAULT NULL,
  seq varchar(10) DEFAULT NULL,
  ack varchar(10) DEFAULT NULL,
  itype char(3) DEFAULT NULL,
  icode char(3) DEFAULT NULL,
  icmp_id varchar(5) DEFAULT NULL,
  icmp_seq varchar(5) DEFAULT NULL,
  content_list varchar(255) DEFAULT NULL,
  session varchar(9) DEFAULT NULL,
  rpc varchar(25) DEFAULT NULL,
  resp varchar(80) DEFAULT NULL,
  react varchar(255) DEFAULT NULL,
  classtype varchar(255) DEFAULT NULL,
  priority varchar(6) DEFAULT NULL,
  tag varchar(255) DEFAULT NULL,
  ip_proto varchar(25) DEFAULT NULL,
  sameip varchar(6) DEFAULT NULL,
  stateless varchar(9) DEFAULT NULL,
  sid INT8  NOT NULL DEFAULT '0',
  rev INT4  NOT NULL DEFAULT '0',
  activates varchar(10) DEFAULT NULL,
  activates_by varchar(10) DEFAULT NULL,
  count varchar(10) DEFAULT NULL,
  operator char(2) NOT NULL DEFAULT '',
  category varchar(255) DEFAULT NULL,
  PRIMARY KEY  (sid,rev)
);

--
-- Dumping data for table 'rules'
--



--
-- Table structure for table 'ruletype'
--



--
-- Sequences for table RULETYPE
--

CREATE SEQUENCE ruletype_id_seq;

CREATE TABLE ruletype (
  ruletype_name varchar(255) NOT NULL DEFAULT '',
  ruletype_value text,
  id INT4 DEFAULT nextval('ruletype_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'ruletype'
--



--
-- Table structure for table 'schema'
--

CREATE TABLE schema (
  vseq INT4  NOT NULL DEFAULT '0',
  ctime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00'
);

--
-- Dumping data for table 'schema'
--


INSERT INTO schema VALUES (3,'2002-08-19 00:00:00');

--
-- Table structure for table 'sensor'
--



--
-- Sequences for table SENSOR
--

CREATE SEQUENCE sensor_id_seq;

CREATE TABLE sensor (
  sensor_name varchar(255) NOT NULL DEFAULT '',
  rules text,
  vars text,
  preprocessor text,
  output text,
  ruletype text,
  config text,
  id INT4 DEFAULT nextval('sensor_id_seq'),
  sensor_ip varchar(15) DEFAULT NULL,
  sensor_port INT4  DEFAULT NULL,
  sensor_user varchar(255) DEFAULT NULL,
  sensor_passw text,
  net_proto varchar(255) DEFAULT NULL,
  cmd_line text,
  interface varchar(255) DEFAULT NULL,
  enable INT4  DEFAULT NULL,
  auto_update INT4  DEFAULT NULL,
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'sensor'
--


INSERT INTO sensor VALUES ('DEFAULT','','','','','','',1,'',0,'','','','','',0,0);

--
-- Table structure for table 'sensor_group'
--



--
-- Sequences for table SENSOR_GROUP
--

CREATE SEQUENCE sensor_group_id_seq;

CREATE TABLE sensor_group (
  group_name varchar(255) NOT NULL DEFAULT '',
  group_value text,
  id INT4 DEFAULT nextval('sensor_group_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'sensor_group'
--



--
-- Table structure for table 'snortcenter_cfg'
--

CREATE TABLE snortcenter_cfg (
  filename varchar(25) DEFAULT NULL,
  md5 varchar(32) DEFAULT NULL
);

--
-- Dumping data for table 'snortcenter_cfg'
--



--
-- Table structure for table 'uricontent'
--

CREATE TABLE uricontent (
  sid INT8  NOT NULL DEFAULT '0',
  uricontent varchar(255) DEFAULT NULL,
  off_set varchar(4) DEFAULT NULL,
  depth varchar(4) DEFAULT NULL,
  nocase varchar(6) DEFAULT NULL,
  regex varchar(5) DEFAULT NULL
);

--
-- Dumping data for table 'uricontent'
--



--
-- Table structure for table 'users'
--



--
-- Sequences for table USERS
--

CREATE SEQUENCE users_id_seq;

CREATE TABLE users (
  id INT4 DEFAULT nextval('users_id_seq'),
  username varchar(20) NOT NULL DEFAULT '',
  password varchar(100) NOT NULL DEFAULT '',
  email varchar(100) NOT NULL DEFAULT '',
  lost char(1) NOT NULL DEFAULT '0',
  acl varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'users'
--


INSERT INTO users VALUES (1,'admin','eb399bcaca686f8609137153307eecf1','admin@domain.here','','sensor|alert');

--
-- Table structure for table 'vars'
--



--
-- Sequences for table VARS
--

CREATE SEQUENCE vars_id_seq;

CREATE TABLE vars (
  var_name varchar(255) NOT NULL DEFAULT '',
  var_value TEXT DEFAULT '' NOT NULL,
  id INT4 DEFAULT nextval('vars_id_seq'),
  PRIMARY KEY  (id)
);

--
-- Dumping data for table 'vars'
--





--
-- Indexes for table SENSOR
--

CREATE UNIQUE INDEX sensor_name_sensor_index ON sensor (sensor_name);

--
-- Indexes for table RULES
--

CREATE INDEX category_rules_index ON rules (category);

--
-- Indexes for table URICONTENT
--

CREATE INDEX sid_uricontent_index ON uricontent (sid);

--
-- Indexes for table REFERENCE
--

CREATE INDEX sid_reference_index ON reference (sid);

--
-- Indexes for table CONTENT
--

CREATE INDEX sid_content_index ON content (sid);

--
-- Indexes for table USERS
--

CREATE UNIQUE INDEX username_users_index ON users (username);

--
-- Sequences for table SENSOR
--

SELECT SETVAL('sensor_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from sensor));

--
-- Sequences for table PREPROCESSOR
--

SELECT SETVAL('preprocessor_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from preprocessor));

--
-- Sequences for table CONFIG
--

SELECT SETVAL('config_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from config));

--
-- Sequences for table USERS
--

SELECT SETVAL('users_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from users));

--
-- Sequences for table SENSOR_GROUP
--

SELECT SETVAL('sensor_group_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from sensor_group));

--
-- Sequences for table OUTPUT
--

SELECT SETVAL('output_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from output));

--
-- Sequences for table VARS
--

SELECT SETVAL('vars_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from vars));

--
-- Sequences for table RULETYPE
--

SELECT SETVAL('ruletype_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from ruletype));

COMMIT;
