<?php
/*
** SnortCenter Copyright (C) 2001,2002 Stefan Dens
**
** Author: Stefan Dens <larc@pandora.be>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
?>
<?php
$db = NewACIDDBConnection($DBlib_path, $DBtype);
$db->acidConnect($DB_dbname, $DB_host, $DB_port, $DB_user, $DB_password);

$db_ver = $db->acidGetDBVersion();
if ($db_ver && $db_ver < 2) {
	echo "Old database version: $db_ver exist<BR>
		First drop the database!<BR>
		!!! All data will be lost !!!<P>";
}
elseif(!$db_ver) {
$tblVars_present = $db->acidTableExists("vars");
$tblConfig_present = $db->acidTableExists("config");
$tblOutput_present = $db->acidTableExists("output");
$tblPreprocessor_present = $db->acidTableExists("preprocessor");
$tblRules_present = $db->acidTableExists("rules");
$tblContent_present = $db->acidTableExists("content");
$tblUricontent_present = $db->acidTableExists("uricontent");
$tblReference_present = $db->acidTableExists("reference");
$tblRulechange_present = $db->acidTableExists("rulechange");
$tblRuletype_present = $db->acidTableExists("ruletype");
$tblSchema_present = $db->acidTableExists("schema");
$tblSensor_present = $db->acidTableExists("sensor");
$tblSensor_group_present = $db->acidTableExists("sensor_group");
$tblSnortcenter_cfg_present = $db->acidTableExists("snortcenter_cfg");
$tblUsers_present = $db->acidTableExists("users");


if (!$tblVars_present) {
    $sql = "CREATE TABLE vars (
    var_name varchar(255) NOT NULL default '',
    var_value blob NOT NULL,
    id int(10) unsigned NOT NULL auto_increment,
    PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'vers': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'vars'",1);
    $tblVars_present = $db->acidTableExists("vars");
}

if (!$tblConfig_present) {
    $sql = "CREATE TABLE config (
      config_name varchar(255) NOT NULL default '',
      config_value blob,
      id int(10) unsigned NOT NULL auto_increment,
      PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'config': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'config'",1);
    $tblConfig_present = $db->acidTableExists("config");
}

if (!$tblOutput_present) {
    $sql = "CREATE TABLE output (
      spo_name varchar(255) NOT NULL default '',
      spo_value blob,
      id int(10) unsigned NOT NULL auto_increment,
      PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'output': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'output'",1);
    $tblOutput_present = $db->acidTableExists("output");
}

if (!$tblPreprocessor_present) {
    $sql = "CREATE TABLE preprocessor (
      spp_name varchar(255) NOT NULL default '',
      spp_value blob,
      id int(10) unsigned NOT NULL auto_increment,
      PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'preprocessor': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'preprocessor'",1);
    $tblPreprocessor_present = $db->acidTableExists("preprocessor");
}

if (!$tblRules_present) {
    $sql = "CREATE TABLE rules (
      action varchar(15) NOT NULL default '',
      proto varchar(5) NOT NULL default '',
      src_ip varchar(255) NOT NULL default '',
      src_port varchar(255) NOT NULL default '',
      dst_ip varchar(255) NOT NULL default '',
      dst_port varchar(255) NOT NULL default '',
      msg varchar(255) default NULL,
      logto varchar(255) default NULL,
      ttl char(3) default NULL,
      tos char(3) default NULL,
      id varchar(5) default NULL,
      ipoption varchar(5) default NULL,
      fragbits varchar(10) default NULL,
      dsize varchar(10) default NULL,
      flags varchar(15) default NULL,
      seq varchar(10) default NULL,
      ack varchar(10) default NULL,
      itype char(3) default NULL,
      icode char(3) default NULL,
      icmp_id varchar(5) default NULL,
      icmp_seq varchar(5) default NULL,
      content_list varchar(255) default NULL,
      session varchar(9) default NULL,
      rpc varchar(25) default NULL,
      resp varchar(80) default NULL,
      react varchar(255) default NULL,
      classtype varchar(255) default NULL,
      priority varchar(6) default NULL,
      tag varchar(255) default NULL,
      ip_proto varchar(25) default NULL,
      sameip varchar(6) default NULL,
      stateless varchar(9) default NULL,
      sid bigint(20) unsigned NOT NULL default '0',
      rev int(10) unsigned NOT NULL default '0',
      activates varchar(10) default NULL,
      activates_by varchar(10) default NULL,
      count varchar(10) default NULL,
      operator char(2) NOT NULL default '',
      category varchar(255) default NULL,
      PRIMARY KEY  (sid,rev),
      KEY category (category)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'rules': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'rules'",1);
    $tblRules_present = $db->acidTableExists("rules");
}

if (!$tblContent_present) {
    $sql = "CREATE TABLE content (
      sid bigint(20) unsigned NOT NULL default '0',
      content varchar(255) default NULL,
      off_set varchar(4) default NULL,
      depth varchar(4) default NULL,
      nocase varchar(6) default NULL,
      regex varchar(5) default NULL,
      KEY sid (sid)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'content': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'content'",1);
    $tblContent_present = $db->acidTableExists("content");
}

if (!$tblUricontent_present) {
    $sql = "CREATE TABLE uricontent (
      sid bigint(20) unsigned NOT NULL default '0',
      uricontent varchar(255) default NULL,
      off_set varchar(4) default NULL,
      depth varchar(4) default NULL,
      nocase varchar(6) default NULL,
      regex varchar(5) default NULL,
      KEY sid (sid)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'uricontent': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'uricontent'",1);
    $tblUricontent_present = $db->acidTableExists("uricontent");
}

if (!$tblReference_present) {
    $sql = "CREATE TABLE reference (
      sid bigint(20) NOT NULL default '0',
      reference varchar(255) default NULL,
      KEY sid (sid)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'reference': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'reference'",1);
    $tblReference_present = $db->acidTableExists("reference");
}

if (!$tblRulechange_present) {
    $sql = "CREATE TABLE rulechange (
      sensor_id int(10) unsigned NOT NULL default '0',
      sid int(10) unsigned NOT NULL default '0',
      action varchar(255) NOT NULL default '',
      src_ip varchar(255) NOT NULL default '',
      src_port varchar(255) NOT NULL default '',
      dst_ip varchar(255) NOT NULL default '',
      dst_port varchar(255) NOT NULL default '',
      PRIMARY KEY  (sensor_id,sid)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'rulechange': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'rulechange'",1);
    $tblRulechange_present = $db->acidTableExists("rulechange");
}

if (!$tblRuletype_present) {
    $sql = "CREATE TABLE ruletype (
      ruletype_name varchar(255) NOT NULL default '',
      ruletype_value blob,
      id int(10) unsigned NOT NULL auto_increment,
      PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'ruletype': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'ruletype'",1);
    $tblRuletype_present = $db->acidTableExists("ruletype");
}

if (!$tblSchema_present) {
    $sql = "CREATE TABLE schema (
      vseq int(10) unsigned NOT NULL default '0',
      ctime datetime NOT NULL default '0000-00-00 00:00:00'
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'schema': ".$db->acidErrorMessage(),0);
    else {
	ErrorMessage("Successfully created 'schema'",1);
	$sql = "INSERT INTO schema VALUES (3, '2002-08-19 00:00:00')";
	$db->acidExecute($sql, -1, -1, false);
	if ( $db->acidErrorMessage() != "" )
	    ErrorMessage("Unable to insert  'schema' values: ".$db->acidErrorMessage(),0);
	else 
	    ErrorMessage("Successfully inserted 'schema' values",1);
    }
    $tblSchema_present = $db->acidTableExists("schema");
}

if (!$tblSensor_present) {
    $sql = "CREATE TABLE sensor (
      sensor_name varchar(255) NOT NULL default '',
      rules longblob,
      vars longblob,
      preprocessor longblob,
      output longblob,
      ruletype longblob,
      config longblob,
      id int(10) unsigned NOT NULL auto_increment,
      sensor_ip varchar(15) default NULL,
      sensor_port int(10) unsigned default NULL,
      sensor_user varchar(255)default NULL,
      sensor_passw blob,
      net_proto varchar(255) default NULL,
      cmd_line blob,
      interface VARCHAR(255) NULL,
      enable int(1) unsigned NULL,
      auto_update int(1) unsigned NULL,
      PRIMARY KEY  (id),
      UNIQUE KEY sensor_name (sensor_name)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'sensor': ".$db->acidErrorMessage(),0);
    else {
	ErrorMessage("Successfully created 'sensor'",1);
	$sql = "INSERT INTO sensor VALUES ('default','','','','','','',1,'','','','','','','','','')";
	$db->acidExecute($sql, -1, -1, false);
	if ( $db->acidErrorMessage() != "" )
	    ErrorMessage("Unable to insert  'default' sensor: ".$db->acidErrorMessage(),0);
	else 
	    ErrorMessage("Successfully inserted 'default' sensor",1);
    }
    $tblSensor_present = $db->acidTableExists("sensor");
}

if (!$tblSensor_group_present) {
    $sql = "CREATE TABLE sensor_group (
      group_name varchar(255) NOT NULL default '',
      group_value longblob,
      id int(10) unsigned NOT NULL auto_increment,
      PRIMARY KEY  (id)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'sensor_group': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'sensor_group'",1);
    $tblSensor_group_present = $db->acidTableExists("sensor_group");
}

if (!$tblSnortcenter_cfg_present) {
    $sql = "CREATE TABLE snortcenter_cfg (
      filename varchar(25) default NULL,
      md5 varchar(32) default NULL
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'snortcenter_cfg': ".$db->acidErrorMessage(),0);
    else
	ErrorMessage("Successfully created 'snortcenter_cfg'",1);
    $tblSnortcenter_cfg_present = $db->acidTableExists("snortcenter_cfg");
}

if (!$tblUsers_present) {
    $sql = "CREATE TABLE users (
      id int(11) NOT NULL auto_increment,
      username varchar(20) NOT NULL default '',
      password varchar(100) NOT NULL default '',
      email varchar(100) NOT NULL default '',
      lost char(1) NOT NULL default '0',
      acl varchar(255) NOT NULL default '',
      PRIMARY KEY  (id),
      UNIQUE KEY username (username)
    )";
    $db->acidExecute($sql, -1, -1, false);
    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to CREATE table 'users': ".$db->acidErrorMessage(),0);
    else {
	ErrorMessage("Successfully created 'users'",1);
	$sql = "INSERT INTO users VALUES (1,'admin','eb399bcaca686f8609137153307eecf1','admin@domain.here','','sensor|alert')";
	$db->acidExecute($sql, -1, -1, false);
	if ( $db->acidErrorMessage() != "" )
	    ErrorMessage("Unable to insert user: 'admin': ".$db->acidErrorMessage(),0);
	else 
	    ErrorMessage("Successfully inserted user: '<BLINK>admin</BLINK>', password '<BLINK>change</BLINK>'",1);
    }
    $tblUsers_present = $db->acidTableExists("users");
}

}
elseif ($db_ver && $db_ver == 2) {
    echo "Updating database version: $db_ver to 3<BR>";

    $sql = "ALTER TABLE users ADD acl VARCHAR(255) NOT NULL";
    $db->acidExecute($sql, -1, -1, false);

    $sql="ALTER TABLE rules CHANGE dsize dsize VARCHAR(10) DEFAULT NULL"; 
    $db->acidExecute($sql, -1, -1, false);

    if ( $db->acidErrorMessage() != "" )
	ErrorMessage("Unable to update table 'users.acl': ".$db->acidErrorMessage(),0);
    else {
	ErrorMessage("Successfully updated 'users'",1);
	$sql = "Update users SET acl='sensor|alert' where username='admin'";
	$db->acidExecute($sql, -1, -1, false);
	
	$sql = "Update schema SET vseq=3, ctime='2002-08-19 00:00:00'";
	$db->acidExecute($sql, -1, -1, false);
        if ( $db->acidErrorMessage() != "" )
	    ErrorMessage("Unable to update table 'Schema': ".$db->acidErrorMessage(),0);
	else {
	    ErrorMessage("Successfully updated 'Schema'",1);
        }
    }	
}



$db->acidClose();
function ErrorMessage ($message,$err)
{
    if ($err == 0)
	echo '<FONT COLOR="#FF0000">'.$message.'</FONT><BR>';
    else
	echo '<FONT COLOR="#FFFFFF">'.$message.'</FONT><BR>';
}
?>

    
        
    
    