<?php
/*
** SnortCenter Copyright (C) 2001,2002 Stefan Dens
**
** Author: Stefan Dens <larc@pandora.be>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
?>
<?php
include_once("list.inc.php");

function pars_rule($rule_line)
{
list ($rule['action'],$rule['proto'],$rule['src_ip'],$rule['src_port'],$rule['operator'],$rule['dst_ip'],$rule['dst_port'],$rule_options) = explode(' ',ltrim($rule_line), 8); //split rule into 7 vars and the rule options in var 8
if ($rule['action'] != '' and strpos($rule['action'], '#') === false) // don't process blank lines or if they start with '#' 
{
	if($rule['action'] == "var" OR $rule['action'] == "preprocessor" OR $rule['action'] == "output"
				 OR $rule['action'] == "ruletype" OR $rule['action'] == "config" 
				 OR $rule['action'] == "include")
	{
		list ($rule['action'],$rule['rule_options']) = explode(' ',ltrim($rule_line), 2);
		return $rule;
	}
	else
	{
		$content_nr = 0;
		$rule_options = substr ($rule_options, 1); // strip left "("
		$rule_options = substr (rtrim($rule_options), 0, -1); // strip right ")"
		$rule_option = preg_split('/(?<!\\\);/',$rule_options); /* split the rule options in a array
 (on ; but not on \; */
		foreach($rule_option as $type)
		{

			list($what,$val) = explode(':',trim($type),2);	// split every rule option into name end value
			$val = addslashes($val); // addslashes for valid database queries
			if ($what == "msg") { $rule['msg']=$val;}
			elseif ($what == "logto") { $rule['logto']=$val;}
			elseif ($what == "ttl") { $rule['ttl']=$val;}
			elseif ($what == "tos") { $rule['tos']=$val;}
			elseif ($what == "id") { $rule['id']=$val;}
			elseif ($what == "ipopts") { $rule['ipoption']=$val;}
			elseif ($what == "fragbits") { $rule['fragbits']=$val;}
			elseif ($what == "dsize") { $rule['dsize']=$val;}
			elseif ($what == "flags") { $rule['flags']=$val;}
			elseif ($what == "seq") { $rule['seq']=$val;}
			elseif ($what == "ack") { $rule['ack']=$val;}
			elseif ($what == "itype") { $rule['itype']=$val;}
			elseif ($what == "icode") { $rule['icode']=$val;}
			elseif ($what == "icmp_id") { $rule['icmp_id']=$val;}
			elseif ($what == "icmp_seq") { $rule['icmp_seq']=$val;}
			elseif ($what == "content") { 
							$content_nr++;
							$rule['content'][$content_nr]=$val;
						    }
			elseif ($what == "uricontent") { 
							$content_nr++;
							$rule['uricontent'][$content_nr]=$val;
						    }
			elseif ($what == "offset") { $rule['off_set'][$content_nr]=$val;}
			elseif ($what == "depth") { $rule['depth'][$content_nr]=$val;}
			elseif ($what == "nocase") { $rule['nocase'][$content_nr]='nocase';}
			elseif ($what == "regex") { $rule['regex'][$content_nr]='regex';}
			elseif ($what == "reference") { $rule['reference'][]=$val;}

			elseif ($what == "content-list") { $rule['content_list']=$val;}
			elseif ($what == "session") { $rule['session']=$val;}
			elseif ($what == "rpc") { $rule['rpc']=$val;}
			elseif ($what == "resp") { $rule['resp']=$val;}
			elseif ($what == "react") { $rule['react']=$val;}
			elseif ($what == "classtype") { $rule['classtype']=$val;}
			elseif ($what == "priority") { $rule['priority']=$val;}
			elseif ($what == "tag") { $rule['tag']=$val;}
			elseif ($what == "ip_proto") { $rule['ip_proto']=$val;}
			elseif ($what == "sameip") { $rule['sameip']='sameip';}
			elseif ($what == "stateless") { $rule['stateless']='stateless';}
			elseif ($what == "sid") { $rule['sid']=$val;}
			elseif ($what == "rev") { $rule['rev']=$val;}
			elseif ($what == "activates") { $rule['activates']=$val;}
			elseif ($what == "activates_by") { $rule['activates_by']=$val;}
			elseif ($what == "count") { $rule['count']=$val;}
			elseif ($what != '') { echo "Unknown Rule option: $what<BR>"; }
		}
	return $rule;		
	}
}
else return;
}


function write_rule($rule,$file,$db,$auto)
{
$update_rule_count='';
	if ($rule)
	{
		if ($rule['action'] == "var")
		{
		list ($var['var_name'],$var['var_value']) = explode(' ',trim($rule['rule_options']),2);
		$sql = "SELECT * FROM vars WHERE var_name = '". $var['var_name'] ."' AND var_value = '". $var['var_value'] ."'";
		$result = $db->acidExecute($sql);
		$myrow = $result->acidFetchRow();
		if ($myrow == 0)
		{
			$sql = "INSERT INTO vars (var_name, var_value)";
			$sql .= " VALUES ( '". $var['var_name'] ."', '" . $var['var_value']."' )";
			//echo "$sql<BR>";
			$result = $db->acidExecute($sql);
			$update_rule_count[0] = 'Variable(s)';
		}
		}
		elseif ($rule['action'] == "preprocessor")
		{
		list ($spp['spp_name'],$spp['spp_value']) = explode(' ',trim($rule['rule_options']),2);
		$sql = "SELECT * FROM preprocessor WHERE spp_name = '". $spp['spp_name'] ."' AND spp_value = '". $spp['spp_value'] ."'";
		$result = $db->acidExecute($sql);
		$myrow = $result->acidFetchRow();
		if ($myrow == 0)
		{
			$sql = "INSERT INTO preprocessor (spp_name, spp_value)";
			$sql .= " VALUES ( '". $spp['spp_name'] ."', '" . $spp['spp_value']."' )";
			//echo "$sql<BR>";
			$result = $db->acidExecute($sql);
			$update_rule_count[0] = 'Preprocessor(s)';
		}
		}
		elseif ($rule['action'] == "output")
		{
		list ($spo['spo_name'],$spo['spo_value']) = explode(' ',trim($rule['rule_options']),2);
		$sql = "SELECT * FROM output WHERE spo_name = '". $spo['spo_name'] ."' AND spo_value = '". $spo['spo_value'] ."'";
		$result = $db->acidExecute($sql);
		$myrow = $result->acidFetchRow();
		if ($myrow == 0)
		{
		$sql = "INSERT INTO output (spo_name, spo_value)";
		$sql .= " VALUES ( '". $spo['spo_name'] ."', '" . $spo['spo_value']."' )";
		//echo "$sql<BR>";
		$result = $db->acidExecute($sql);
		$update_rule_count[0] = 'Output Plugin(s)';
		}
		}
		elseif ($rule['action'] == "ruletype")
		{
		list ($ruletype['ruletype_name'],$ruletype['ruletype_value']) = explode(' ',trim($rule['rule_options']),2);
		$pos_start = strpos ($ruletype['ruletype_value'], '{');
		$pos_end = strpos ($ruletype['ruletype_value'], '}');
		if (($pos_start === false AND $pos_end === false) OR $pos_end === false)
		{ 
		while (!feof ($fd) AND strpos ($rule['ruleoptions'], '}') === false)
			{
			$rule['ruleoptions'] = fgets($fd, 4096);
			$ruletype['ruletype_value'] .= '\n'.trim($rule['ruleoptions']);
			}
		}
		$sql = "SELECT * FROM ruletype WHERE ruletype_name = '". $ruletype['ruletype_name'] ."' AND ruletype_value = '". $ruletype['ruletype_value'] ."'";
		$result = $db->acidExecute($sql);
		$myrow = $result->acidFetchRow();
		if ($myrow == 0)
		{
			$sql = "INSERT INTO ruletype (ruletype_name, ruletype_value)";
			$sql .= " VALUES ( '". $ruletype['ruletype_name'] ."', '" . $ruletype['ruletype_value']."' )";
			//echo "$sql<BR>";
			$result = $db->acidExecute($sql);
			$update_rule_count[0] = 'Ruletype(s)';
		}
		}
		elseif ($rule['action'] == "config")
		{
		list ($config['config_name'],$config['config_value']) = explode(' ',trim($rule['rule_options']),2);

		$sql = "SELECT * FROM config WHERE config_name = '". $config['config_name'] ."' AND config_value = '". $config['config_value'] ."'";
		$result = $db->acidExecute($sql);
		$myrow = $result->acidFetchRow();
		if ($myrow == 0)
		{
		    $sql = "INSERT INTO config (config_name, config_value)";
			$sql .= " VALUES ( '". $config['config_name'] ."', '" . $config['config_value']."' )";
			//echo "$sql<BR>";
			$result = $db->acidExecute($sql);
			$update_rule_count[0] = $file;
		}
		}
		elseif ($rule['action'] == "include"){ }

		else // action should be a rule
		{
		    $sql = "SELECT * FROM rules WHERE sid = '". $rule['sid'] ."'";
		    $result = $db->acidExecute($sql);
    		    $myrow = $result->acidFetchRow();
		    if ($myrow == 0)
		    {
			if($rule['content'])
			{
			    foreach($rule['content'] as $content_nr => $content)
			    {
	    			$sql_content = "INSERT INTO content (sid, content, off_set, depth, nocase, regex) VALUES ('". $rule['sid'] ."', '" . $content ."', '" . $rule['off_set'][$content_nr] ."', '" . $rule['depth'][$content_nr] ."', '" . $rule['nocase'][$content_nr] ."', '" . $rule['regex'][$content_nr]. "')"; 
				$result = $db->acidExecute($sql_content);
			    }
			}
			if($rule['uricontent'])
			{
			    foreach($rule['uricontent'] as $content_nr => $uricontent)
			    {
	    			$sql_uricontent = "INSERT INTO uricontent (sid, uricontent, off_set, depth, nocase, regex) VALUES ('". $rule['sid'] ."', '" . $uricontent ."', '" . $rule['off_set'][$content_nr] ."', '" . $rule['depth'][$content_nr] ."', '" . $rule['nocase'][$content_nr] ."', '" . $rule['regex'][$content_nr]. "')"; 
				$result = $db->acidExecute($sql_uricontent);
			    }
			}
			if($rule['reference'])
			{
			    foreach($rule['reference'] as  $reference)
			    {
	    			$sql_reference = "INSERT INTO reference (sid, reference) VALUES ('". $rule['sid'] ."', '" . $reference . "')"; 
				$result = $db->acidExecute($sql_reference);
			    }
			}			
			$sql = "INSERT INTO rules (action, proto, src_ip, src_port, operator, dst_ip, dst_port, msg, logto, ttl, tos, id, ipoption, fragbits, dsize, flags, seq, ack, itype, icode, icmp_id, icmp_seq, content_list, session, rpc, resp, react, classtype, priority, tag, ip_proto, sameip, stateless, sid, rev, activates, activates_by, count, category)";
		        $sql .= " VALUES ( '". $rule['action'] ."', '" . $rule['proto'] ."', '" . $rule['src_ip'] ."', '" . $rule['src_port'] ."', '" . $rule['operator'] ."', '" . $rule['dst_ip'] ."', '" . $rule['dst_port'] ."', '" . $rule['msg'] ."', '" . $rule['logto'] ."', '" . $rule['ttl'] ."', '" . $rule['tos'] ."', '" . $rule['id'] ."', '" . $rule['ipoption'] ."', '" . $rule['fragbits'] ."', '" . $rule['dsize'] ."', '" . $rule['flags'] ."', '" . $rule['seq'] ."', '" . $rule['ack'] ."', '" . $rule['itype'] ."', '" . $rule['icode'] ."', '" . $rule['icmp_id'] ."', '" . $rule['icmp_seq'] ."', '" . $rule['content_list'] ."', '" . $rule['session'] ."', '" . $rule['rpc'] ."', '" . $rule['resp'] ."', '" . $rule['react'] ."', '" . $rule['classtype'] ."', '" . $rule['priority'] ."', '" . $rule['tag'] ."', '" . $rule['ip_proto'] ."', '" . $rule['sameip'] ."', '" . $rule['stateless'] ."', '" . $rule['sid'] ."', '" . $rule['rev'] ."', '" . $rule['activates'] ."', '" . $rule['activates_by'] ."', '" . $rule['count'] ."', '$file' )";
			//echo "$sql<BR>";
			$result = $db->acidExecute($sql);
# auto activate
#
if($auto == 1) {
    $result = $db->acidExecute("select id, rules from sensor");
    while ($myrow = $result->acidFetchRow())
    {
        $myrow_act=$myrow['rules'];
	$key = $rule['sid'];
	if(!strstr($myrow_act,"|$key|;")){
		$myrow_act .= "|$key|;";
    	    }
	$sql = "UPDATE sensor SET rules='$myrow_act' where id = '".$myrow['id']."'";
	$result_id = $db->acidExecute($sql);
    }
    $result->acidFreeRows();
}
#
#
			
			$update_rule_count[0] = $file;
			# $update_rule_count[1] = '-Add- sid: '.$rule['sid'].'; rev: '.$rule['rev'].'; msg: '.stripslashes($rule['msg']).';';
			$update_rule_count[1] = '-Add-';
		    }
		    else
		    {
			$result = $db->acidExecute("DELETE FROM content WHERE sid='".$rule['sid']."'");
			if($rule['content'])
			{
			    foreach($rule['content'] as $content_nr => $content)
			    {
	    			$sql_content = "INSERT INTO content (sid, content, off_set, depth, nocase, regex) VALUES ('". $rule['sid'] ."', '" . $content ."', '" . $rule['off_set'][$content_nr] ."', '" . $rule['depth'][$content_nr] ."', '" . $rule['nocase'][$content_nr] ."', '" . $rule['regex'][$content_nr]. "')"; 
				$result = $db->acidExecute($sql_content);
			    }
			}
			$result = $db->acidExecute("DELETE FROM uricontent WHERE sid='".$rule['sid']."'");
			if($rule['uricontent'])
			{
			    foreach($rule['uricontent'] as $content_nr => $uricontent)
			    {
	    			$sql_content = "INSERT INTO uricontent (sid, uricontent, off_set, depth, nocase, regex) VALUES ('". $rule['sid'] ."', '" . $uricontent ."', '" . $rule['off_set'][$content_nr] ."', '" . $rule['depth'][$content_nr] ."', '" . $rule['nocase'][$content_nr] ."', '" . $rule['regex'][$content_nr]. "')"; 
				$result = $db->acidExecute($sql_content);
			    }
			}
			$result = $db->acidExecute("DELETE FROM reference WHERE sid='".$rule['sid']."'");
			if($rule['reference'])
			{
			    foreach($rule['reference'] as  $reference)
			    {
	    			$sql_reference = "INSERT INTO reference (sid, reference) VALUES ('". $rule['sid'] ."', '" . $reference . "')"; 
				$result = $db->acidExecute($sql_reference);
			    }
			}			
			$sql = "SELECT * FROM rules WHERE sid = '". $rule['sid'] ."' AND rev < '". $rule['rev'] ."'";
			$result = $db->acidExecute($sql);
			$myrow = $result->acidFetchRow();
			if (!$myrow == 0)
			{
			    $sql = "UPDATE rules SET action = '". $rule['action'] ."', proto = '" . $rule['proto'] ."', src_ip = '" . $rule['src_ip'] ."', src_port = '" . $rule['src_port'] ."', operator = '" . $rule['operator'] ."', dst_ip = '" . $rule['dst_ip'] ."', dst_port = '" . $rule['dst_port'] ."', msg = '" . $rule['msg'] ."', logto = '" . $rule['logto'] ."', ttl = '" . $rule['ttl'] ."', tos = '" . $rule['tos'] ."', id = '" . $rule['id'] ."', ipoption = '" . $rule['ipoption'] ."', fragbits = '" . $rule['fragbits'] ."', dsize = '" . $rule['dsize'] ."', flags = '" . $rule['flags'] ."', seq = '" . $rule['seq'] ."', ack = '" . $rule['ack'] ."', itype = '" . $rule['itype'] ."', icode = '" . $rule['icode'] ."', icmp_id = '" . $rule['icmp_id'] ."', icmp_seq = '" . $rule['icmp_seq'] ."', content_list = '" . $rule['content_list'] ."', session = '" . $rule['session'] ."', rpc = '" . $rule['rpc'] ."', resp = '" . $rule['resp'] ."', react = '" . $rule['react'] ."', classtype = '" . $rule['classtype'] ."', priority = '" . $rule['priority'] ."', tag = '" . $rule['tag'] ."', ip_proto = '" . $rule['ip_proto'] ."', sameip = '" . $rule['sameip'] ."', stateless = '" . $rule['stateless'] ."', sid = '" . $rule['sid'] ."', rev = '" . $rule['rev'] ."', activates = '" . $rule['activates'] ."', activates_by = '" . $rule['activates_by'] ."', count = '" . $rule['count'] ."', category = '$file' WHERE sid = '". $rule['sid'] ."'";
			    //echo "$sql<BR>";
			    $result = $db->acidExecute($sql);
			    $update_rule_count[0] = $file;
#			    $update_rule_count[1] = '-Update- sid: '.$rule['sid'].'; rev: '.$rule['rev'].'; msg: '.stripslashes($rule['msg']).';';
			    $update_rule_count[1] = '-Update-';
			}
		    }
		}
	}
return $update_rule_count;
}
?>